// UClient.h
//
// Virtual class that forks a process for a generic
// RPC client
//

#ifndef _UClient_H_
#define _UClient_H_

#include <stream.h>
#include <rpc/rpc.h>
#include <string.h>


typedef struct {
  int       command;
  void*     params;
} ParamStruct;

class TClient
{
protected:

  CLIENT*             client;
  
public:
  virtual
  int      Init( );
  virtual
  void             Dispose( );

  virtual
  int      callService( void* p ) = 0;

  virtual
  void             setParams( void* param ) { fParams = (ParamStruct*)param; }
  // sets the fParams data member

  virtual
  void             setValid( int val ) { fValid = val; }
  // sets the fParams data member
  
protected:
  int       fParentID;
  int       fChildID;
  ParamStruct*    fParams;  // Generic parameters
  int             fValid;

  virtual   void            LowLevelProcess ( );
  friend    void            clientChildMain (void* userData);

};

#endif

