// dypersClient.h
//
// Virtual class that forks a process for a generic
// RPC client
//

#ifndef _DypersClient_H_
#define _DypersClient_H_


#include <rpc/rpc.h>
#include <stream.h>
#include <string.h>
extern "C" {
#include "dypersRPC_clnt.h"
  }
#include "UClient.h"



typedef enum {LEARN=1, GETREC=2} dypersCommands;

class dypersClient : protected TClient
{
public:
    int      Init( char* serverName=0 );
    
    void             Dispose( );
    
    int      connect( char* serverName );

    int      callService( void* p );

    int      learnObject( int id );
    int      getRecObject( dypersRecResult &r );

    // Communication with the parent process
    void                        setParams( void* params );
    void                        setValid( int val );
};

#endif


